Index: src/pitch/pitchdetection.c
===================================================================
--- src/pitch/pitchdetection.c	(revision c0b295c7380f35851e124b0cedd01e7620725bec)
+++ src/pitch/pitchdetection.c	(revision 129486275d99b061f4fe7f75afd395b61b0c1e81)
@@ -196,5 +196,5 @@
 }
 
-smpl_t aubio_pitchdetection(aubio_pitchdetection_t *p, fvec_t * ibuf) {
+smpl_t aubio_pitchdetection_do (aubio_pitchdetection_t *p, fvec_t * ibuf) {
   return p->freqconv(p->callback(p,ibuf),p->srate,p->bufsize);
 }
@@ -204,5 +204,5 @@
   aubio_filter_do(p->filter,ibuf);
   aubio_pvoc_do(p->pv,ibuf,p->fftgrain);
-  pitch = aubio_pitchmcomb_detect(p->mcomb,p->fftgrain);
+  pitch = aubio_pitchmcomb_do(p->mcomb,p->fftgrain);
   /** \bug should move the >0 check within aubio_bintofreq */
   if (pitch>0.) {
@@ -230,5 +230,5 @@
   smpl_t pitch = 0.;
   aubio_pitchdetection_slideblock(p,ibuf);
-  pitch = aubio_pitchyinfft_detect(p->yinfft,p->buf,p->yinthres);
+  pitch = aubio_pitchyinfft_do(p->yinfft,p->buf,p->yinthres);
   if (pitch>0) {
     pitch = p->srate/(pitch+0.);
@@ -241,9 +241,9 @@
 smpl_t aubio_pitchdetection_fcomb(aubio_pitchdetection_t *p, fvec_t *ibuf){
   aubio_pitchdetection_slideblock(p,ibuf);
-  return aubio_pitchfcomb_detect(p->fcomb,p->buf);
+  return aubio_pitchfcomb_do(p->fcomb,p->buf);
 }
 
 smpl_t aubio_pitchdetection_schmitt(aubio_pitchdetection_t *p, fvec_t *ibuf){
   aubio_pitchdetection_slideblock(p,ibuf);
-  return aubio_pitchschmitt_detect(p->schmitt,p->buf);
-}
+  return aubio_pitchschmitt_do(p->schmitt,p->buf);
+}
Index: src/pitch/pitchdetection.h
===================================================================
--- src/pitch/pitchdetection.h	(revision c0b295c7380f35851e124b0cedd01e7620725bec)
+++ src/pitch/pitchdetection.h	(revision 129486275d99b061f4fe7f75afd395b61b0c1e81)
@@ -59,5 +59,5 @@
 
 */
-smpl_t aubio_pitchdetection(aubio_pitchdetection_t * p, fvec_t * ibuf);
+smpl_t aubio_pitchdetection_do (aubio_pitchdetection_t * p, fvec_t * ibuf);
 
 /** change yin or yinfft tolerance threshold
Index: src/pitch/pitchfcomb.c
===================================================================
--- src/pitch/pitchfcomb.c	(revision c0b295c7380f35851e124b0cedd01e7620725bec)
+++ src/pitch/pitchfcomb.c	(revision 129486275d99b061f4fe7f75afd395b61b0c1e81)
@@ -59,5 +59,5 @@
 
 /* input must be stepsize long */
-smpl_t aubio_pitchfcomb_detect (aubio_pitchfcomb_t * p, fvec_t * input)
+smpl_t aubio_pitchfcomb_do (aubio_pitchfcomb_t * p, fvec_t * input)
 {
   uint_t k, l, maxharm = 0;
Index: src/pitch/pitchfcomb.h
===================================================================
--- src/pitch/pitchfcomb.h	(revision c0b295c7380f35851e124b0cedd01e7620725bec)
+++ src/pitch/pitchfcomb.h	(revision 129486275d99b061f4fe7f75afd395b61b0c1e81)
@@ -48,5 +48,5 @@
  
 */
-smpl_t aubio_pitchfcomb_detect (aubio_pitchfcomb_t *p, fvec_t * input);
+smpl_t aubio_pitchfcomb_do (aubio_pitchfcomb_t *p, fvec_t * input);
 /** creation of the pitch detection object
  
Index: src/pitch/pitchmcomb.c
===================================================================
--- src/pitch/pitchmcomb.c	(revision c0b295c7380f35851e124b0cedd01e7620725bec)
+++ src/pitch/pitchmcomb.c	(revision 129486275d99b061f4fe7f75afd395b61b0c1e81)
@@ -90,5 +90,5 @@
 
 
-smpl_t aubio_pitchmcomb_detect(aubio_pitchmcomb_t * p, cvec_t * fftgrain) {
+smpl_t aubio_pitchmcomb_do (aubio_pitchmcomb_t * p, cvec_t * fftgrain) {
   uint_t i=0,j;
   smpl_t instfreq;
Index: src/pitch/pitchmcomb.h
===================================================================
--- src/pitch/pitchmcomb.h	(revision c0b295c7380f35851e124b0cedd01e7620725bec)
+++ src/pitch/pitchmcomb.h	(revision 129486275d99b061f4fe7f75afd395b61b0c1e81)
@@ -49,5 +49,5 @@
  
 */
-smpl_t aubio_pitchmcomb_detect(aubio_pitchmcomb_t * p, cvec_t * fftgrain);
+smpl_t aubio_pitchmcomb_do (aubio_pitchmcomb_t * p, cvec_t * fftgrain);
 /** select the best candidates */
 uint_t aubio_pitch_cands(aubio_pitchmcomb_t * p, cvec_t * fftgrain, smpl_t * cands);
Index: src/pitch/pitchschmitt.c
===================================================================
--- src/pitch/pitchschmitt.c	(revision c0b295c7380f35851e124b0cedd01e7620725bec)
+++ src/pitch/pitchschmitt.c	(revision 129486275d99b061f4fe7f75afd395b61b0c1e81)
@@ -43,5 +43,5 @@
 }
 
-smpl_t aubio_pitchschmitt_detect (aubio_pitchschmitt_t *p, fvec_t * input)
+smpl_t aubio_pitchschmitt_do (aubio_pitchschmitt_t *p, fvec_t * input)
 {
   uint_t i;
Index: src/pitch/pitchschmitt.h
===================================================================
--- src/pitch/pitchschmitt.h	(revision c0b295c7380f35851e124b0cedd01e7620725bec)
+++ src/pitch/pitchschmitt.h	(revision 129486275d99b061f4fe7f75afd395b61b0c1e81)
@@ -48,5 +48,5 @@
  
 */
-smpl_t aubio_pitchschmitt_detect (aubio_pitchschmitt_t *p, fvec_t * input);
+smpl_t aubio_pitchschmitt_do (aubio_pitchschmitt_t *p, fvec_t * input);
 /** creation of the pitch detection object
  
Index: src/pitch/pitchyinfft.c
===================================================================
--- src/pitch/pitchyinfft.c	(revision c0b295c7380f35851e124b0cedd01e7620725bec)
+++ src/pitch/pitchyinfft.c	(revision 129486275d99b061f4fe7f75afd395b61b0c1e81)
@@ -88,5 +88,5 @@
 }
 
-smpl_t aubio_pitchyinfft_detect(aubio_pitchyinfft_t * p, fvec_t * input, smpl_t tol) {
+smpl_t aubio_pitchyinfft_do (aubio_pitchyinfft_t * p, fvec_t * input, smpl_t tol) {
   uint_t tau, l = 0;
   uint_t halfperiod;
Index: src/pitch/pitchyinfft.h
===================================================================
--- src/pitch/pitchyinfft.h	(revision c0b295c7380f35851e124b0cedd01e7620725bec)
+++ src/pitch/pitchyinfft.h	(revision 129486275d99b061f4fe7f75afd395b61b0c1e81)
@@ -49,5 +49,5 @@
  
 */
-smpl_t aubio_pitchyinfft_detect (aubio_pitchyinfft_t *p, fvec_t * input, smpl_t tol);
+smpl_t aubio_pitchyinfft_do (aubio_pitchyinfft_t *p, fvec_t * input, smpl_t tol);
 /** creation of the pitch detection object
  