Index: examples/jackio.c
===================================================================
--- examples/jackio.c	(revision 8b2aafd78c3f5c08ce9b380bd3cd0c8d2afd3ada)
+++ examples/jackio.c	(revision 75858228013a15f4389a6370f82c488836f0bc02)
@@ -22,5 +22,5 @@
 #include "config.h"
 
-#if HAVE_JACK
+#ifdef HAVE_JACK
 #include "utils.h" // for aubio_process_func_t
 #include "jackio.h"
Index: examples/utils.c
===================================================================
--- examples/utils.c	(revision 8b2aafd78c3f5c08ce9b380bd3cd0c8d2afd3ada)
+++ examples/utils.c	(revision 75858228013a15f4389a6370f82c488836f0bc02)
@@ -73,5 +73,5 @@
 #if HAVE_JACK
 aubio_jack_t *jack_setup;
-#endif
+#endif /* HAVE_JACK */
 
 void examples_common_init (int argc, char **argv);
@@ -115,5 +115,5 @@
     samplerate = aubio_jack_get_samplerate (jack_setup);
     source_uri = "jack";
-#endif
+#endif /* HAVE_JACK */
   }
   ibuf = new_fvec (hop_size);
@@ -138,5 +138,5 @@
   if (usejack) {
 
-#if HAVE_JACK
+#ifdef HAVE_JACK
     debug ("Jack activation ...\n");
     aubio_jack_activate (jack_setup, process_func);
@@ -144,8 +144,8 @@
     pause ();
     aubio_jack_close (jack_setup);
-#else
+#else /* HAVE_JACK */
     usage (stderr, 1);
     outmsg ("Compiled without jack output, exiting.\n");
-#endif
+#endif /* HAVE_JACK */
 
   } else {
@@ -182,5 +182,5 @@
 {
   smpl_t mpitch = floor (aubio_freqtomidi (pitch) + .5);
-#if HAVE_JACK
+#ifdef HAVE_JACK
   jack_midi_event_t ev;
   ev.size = 3;
Index: src/cvec.c
===================================================================
--- src/cvec.c	(revision 8b2aafd78c3f5c08ce9b380bd3cd0c8d2afd3ada)
+++ src/cvec.c	(revision 75858228013a15f4389a6370f82c488836f0bc02)
@@ -86,8 +86,8 @@
     return;
   }
-#if HAVE_MEMCPY_HACKS
+#ifdef HAVE_MEMCPY_HACKS
   memcpy(t->norm, s->norm, t->length * sizeof(smpl_t));
   memcpy(t->phas, s->phas, t->length * sizeof(smpl_t));
-#else
+#else /* HAVE_MEMCPY_HACKS */
   uint_t j;
   for (j=0; j< t->length; j++) {
@@ -95,5 +95,5 @@
     t->phas[j] = s->phas[j];
   }
-#endif
+#endif /* HAVE_MEMCPY_HACKS */
 }
 
@@ -106,9 +106,9 @@
 
 void cvec_norm_zeros(cvec_t *s) {
-#if HAVE_MEMCPY_HACKS
+#ifdef HAVE_MEMCPY_HACKS
   memset(s->norm, 0, s->length * sizeof(smpl_t));
-#else
+#else /* HAVE_MEMCPY_HACKS */
   cvec_norm_set_all (s, 0.);
-#endif
+#endif /* HAVE_MEMCPY_HACKS */
 }
 
@@ -125,5 +125,5 @@
 
 void cvec_phas_zeros(cvec_t *s) {
-#if HAVE_MEMCPY_HACKS
+#ifdef HAVE_MEMCPY_HACKS
   memset(s->phas, 0, s->length * sizeof(smpl_t));
 #else
Index: src/fmat.c
===================================================================
--- src/fmat.c	(revision 8b2aafd78c3f5c08ce9b380bd3cd0c8d2afd3ada)
+++ src/fmat.c	(revision 75858228013a15f4389a6370f82c488836f0bc02)
@@ -94,12 +94,12 @@
 
 void fmat_zeros(fmat_t *s) {
-#if HAVE_MEMCPY_HACKS
+#ifdef HAVE_MEMCPY_HACKS
   uint_t i;
   for (i=0; i< s->height; i++) {
     memset(s->data[i], 0, s->length * sizeof(smpl_t));
   }
-#else
+#else /* HAVE_MEMCPY_HACKS */
   fmat_set(s, 0.);
-#endif
+#endif /* HAVE_MEMCPY_HACKS */
 }
 
@@ -129,7 +129,7 @@
 void fmat_copy(const fmat_t *s, fmat_t *t) {
   uint_t i;
-#if !HAVE_MEMCPY_HACKS
+#ifndef HAVE_MEMCPY_HACKS
   uint_t j;
-#endif
+#endif /* HAVE_MEMCPY_HACKS */
   if (s->height != t->height) {
     AUBIO_ERR("trying to copy %d rows to %d rows \n",
@@ -142,9 +142,9 @@
     return;
   }
-#if HAVE_MEMCPY_HACKS
+#ifdef HAVE_MEMCPY_HACKS
   for (i=0; i< s->height; i++) {
     memcpy(t->data[i], s->data[i], t->length * sizeof(smpl_t));
   }
-#else
+#else /* HAVE_MEMCPY_HACKS */
   for (i=0; i< t->height; i++) {
     for (j=0; j< t->length; j++) {
@@ -152,5 +152,5 @@
     }
   }
-#endif
+#endif /* HAVE_MEMCPY_HACKS */
 }
 
Index: src/spectral/phasevoc.c
===================================================================
--- src/spectral/phasevoc.c	(revision 8b2aafd78c3f5c08ce9b380bd3cd0c8d2afd3ada)
+++ src/spectral/phasevoc.c	(revision 75858228013a15f4389a6370f82c488836f0bc02)
@@ -143,5 +143,5 @@
   smpl_t * dataold = pv->dataold->data;
   smpl_t * datanew = new->data;
-#if !HAVE_MEMCPY_HACKS
+#ifndef HAVE_MEMCPY_HACKS
   uint_t i;
   for (i = 0; i < pv->end; i++)